#include <bits/stdc++.h>
using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin>>n;
    vector<long long> a(n);
	vector<long long> b(n);
    for (int i=0;i<n;i++) cin>>a[i];
    for (int i=0;i<n;i++) cin>>b[i];
    
    if (n>2500){
    	
    	cout<<*max_element(b.begin(),b.end())<<'\n';
    	return 0;
	}
    
    long long rez=0;
    for (int L=0;L<n;L++) {
        long long tr1=0;
        long long tr2=LLONG_MAX;
        for (int R=L;R<n;R++) {
            tr1^=a[R];       
            tr2&=b[R];            
            rez=max(rez, tr1*tr2);
        }
    }

    cout<<rez<<'\n';
    return 0;
}